pro uti_difif, chstart=chstart, chend=chend, no_notify=no_notify

common global
common data_set

print, 'Calculating differences between two IFs ...'

int0=in[pil[0]].int
result=dat_list(s_l,'"int" eq "'+strcompress(string(int0),/remove_all)+'" and "iband" gt "0" and "iband" lt "25"',/no_notify,/reset)
result=uti_distinct(sp[psl].iband,nb0)
;print,nb0

result=dat_list(s_l,/reset)
nch=sp[psl].nch
j=where(nch eq 1, count)
if (count le 0) then begin
   print,' *** NO CONTINUUM BAND IN FILTER ! ***'
   print,' *** PLEASE RESET FILTER TO INCLUDE CONTINUUM BANDS ***'
   return
endif

j=where(nch gt 1,count)
if (count le 0) then begin
   print,' *** NO SPECTRUM BAND IN FILTER ! ***'
   print,' ***   PLEASE RESET THE FILTER !   ***'
   return
endif

distinct_band=uti_distinct(c.band[sp[psl].iband],nband,/many_repeat)
nch=sp[psl].nch

icont=where(nch eq 1, count)
if (count le 0) then begin
   print,' *** NO CONTINUUM BAND IN FILTER ! ***'
   print,' ***   PLEASE RESET THE FILTER !   ***'
   return
endif

acont=icont[0L:count-2L]
bcont=icont[1L:count-1L]
ccont=bcont-acont
i=where((ccont le 1) or (ccont gt nband),temp)
if (temp gt 0) then begin
   int_bad=uti_distinct(in[pil[icont[i]]].int,nint_bad,/many_repeat)
   print, ' No CORRESPONDING SPECTRA BAND in integrations:'
   print, int_bad
   print, ' ***   CHECK/FLAG THE DATA AND RESET FILTER !      ***'
   return
endif

for i=0L, count-1L do begin
   if i eq count-1L then nb=n_elements(pcl)-icont[count-1L]-1 else nb=icont[i+1]-icont[i]-1
   npts=nch[icont[i]+1:icont[i]+nb]
        skip1 = fix(  (1 - 82./104.)*npts/2.  )
        skip2 = fix(  (1 - 82./104.)*npts/2.  )
        first = pcl[icont[i]+1:icont[i]+nb]
        if (  keyword_set(chstart)) then begin
           if (n_elements(chstart) gt 1) then begin
              if (n_elements(chstart) ne n_elements(npts)) or (n_elements(chend) ne n_elements(npts)) then begin
                 print, 'Wrong number of chstart/chend !'
                 print, 'Please reset chstart/chend !'
                 return
              endif else begin
                 skip1=chstart - 1
                 skip2=npts - chend
              endelse
           endif else begin
              skip1 = make_array(n_elements(npts),/long,value=chstart)-1
              skip2 =  make_array(n_elements(npts),/long)
              skip2 =  npts - chend 
           endelse
        endif
        cmp=complex(0,0)
        for j=0,nb0-1 do begin
           cmp=cmp+total(ch[first[j]+skip1[j]:first[j]+npts[j]-skip2[j]-1])/(npts[j]-skip2[j]-skip1[j])
        endfor
        ch[pcl[icont[i]]]=cmp/nb0
        uti_conv_apc,cmp/nb0,amp1,pha1,/amp_pha
        if nb0 eq nb then begin
           bl[pbl[icont[i]]].tpvar=uti_pha_180(pha1)
        endif else begin
           cmp=complex(0,0)
           for j=nb0,nb-1 do begin
              cmp=cmp+total(ch[first[j]+skip1[j]:first[j]+npts[j]-skip2[j]-1])/(npts[j]-skip2[j]-skip1[j])
           endfor
           ch[pcl[icont[i]]]=cmp/(nb-nb0)
           uti_conv_apc,cmp/(nb-nb0),amp2,pha2,/amp_pha
           bl[pbl[icont[i]]].tpvar=uti_pha_180(pha2-pha1)
           bl[pbl[icont[i]]].sigcoh=amp2/amp1
        endelse
endfor

if not keyword_set(no_notify) then begin
   print, ''
   print, "Phase differences (IF2-IF1) stored in variable 'tpvar'. "
   print, "Amplitude ratios (IF2/IF1) stored in variable 'sigcoh'. "
   print, 'To plot the variable vs time or integration number:'
   print, "    IDL> plot_var,x='dhrs', y='tpvar', frame_v='blcd,rec,sb'"
   print, " or IDL> plot_var,x='int',  y='sigcoh', frame_v='blcd,rec,sb'"
   print, ''
   print, 'To plot both amp ratios and phase differences:'
   print, "    IDL> plot_continuum,y='difif'" 
   print, " /preavg keyword can be used in this context."
   print, ''
endif

result=dat_list(s_l,/reset)

end


